% Clear workspace
clear all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Includes
% Add path to utility functions directory
addpath(genpath('./utils'));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Definitions
% Serial communication port number
COM_PORT_NUMBER = "COM4";
% Baud rate for serial communication
BAUD_RATE = double(115200);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Variable Initialization

% Number of the last saved attack_data file - default is 0
start_file_number = 0;

% Initialize file number
file_number = start_file_number;

% Number of encryptions saved per trace dataset. Separate trace datasets will be used for ease
numofencryptions = 100;

% Total number of encryptions to be performed - 1st-order: 100,000
total_encryptions = 10000;%100000

% Number of trace datasets
total_runs = total_encryptions / numofencryptions;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% Encryption Setup. Use one of the following cases:
% AES/PRESENT/LED

ENC_ID = "AES";

VERIF = 1;

encryption_setup;

% Execution
% Loop through each file number
for i = start_file_number:total_runs

    % Clear everything except variables used across the scripts
    clearvars -except ciphertext_length data_type decMtxKey_matlab_aes hexMtxKey_matlab_aes key key_for_matlab_computation_dec key_for_matlab_computation_hex key_hex key_length plaintext plaintext_length reshapedStringKey_matlab_aes i ENC_ID VERIF BAUD_RATE COM_PORT_NUMBER total_encryptions total_runs numofencryptions file_number
    
    % Increment file number & display
    file_number = file_number + 1

    % Start timer
    tic

    % Perform encryptions
    perform_encryptions;

    % End timer and display elapsed time
    toc

end
