function hexstr = bin2hex(binstr)
%  BIN2HEX Convert binary string to hexadecimal integer.
%     H = BIN2HEX(B) interprets the binary string B and returns in H the
%     equivalent hexadecimal number.


if(mod(length(binstr),4)~=0)
    error('Input string must a multiple of 4 in length. Please pad zeros accordingly');
end

hexstr = repmat('0',1,length(binstr)/4);

hexIndex = 1;
for i=1:4:length(binstr)
    switch binstr(i:i+3)
        case '0000', hexstr(hexIndex) = '0';
        case '0001', hexstr(hexIndex) = '1';
        case '0010', hexstr(hexIndex) = '2';
        case '0011', hexstr(hexIndex) = '3';
            
        case '0100', hexstr(hexIndex) = '4';
        case '0101', hexstr(hexIndex) = '5';
        case '0110', hexstr(hexIndex) = '6';
        case '0111', hexstr(hexIndex) = '7';
            
        case '1000', hexstr(hexIndex) = '8';
        case '1001', hexstr(hexIndex) = '9';
        case '1010', hexstr(hexIndex) = 'A';
        case '1011', hexstr(hexIndex) = 'B';
            
        case '1100', hexstr(hexIndex) = 'C';
        case '1101', hexstr(hexIndex) = 'D';
        case '1110', hexstr(hexIndex) = 'E';
        case '1111', hexstr(hexIndex) = 'F';
            
        otherwise, hexstr(hexIndex) = 'X';
            
    end
    hexIndex = hexIndex+1;
end

